SkipBlockRangeIterator (Lucene 10.5.1 core API)
Description: declaration: package: org.apache.lucene.search, class: SkipBlockRangeIterator

Package org.apache.lucene.search

# Class SkipBlockRangeIterator

java.lang.Object
org.apache.lucene.search.DocIdSetIterator
org.apache.lucene.search.AbstractDocIdSetIterator
org.apache.lucene.search.SkipBlockRangeIterator

public class SkipBlockRangeIterator extends AbstractDocIdSetIterator
A DocIdSetIterator that returns all documents within DocValuesSkipper blocks that have minimum and maximum values that fall within a specified range.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static enum`
  `SkipBlockRangeIterator.Match`
  The match state of the current positioned block

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.search.AbstractDocIdSetIterator

  `doc`

  ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

  `NO_MORE_DOCS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `SkipBlockRangeIterator(DocValuesSkipper skipper, long minValue, long maxValue)`
  Creates a new SkipBlockRangeIterator

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `advance(int target)`
  Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
  `int`
  `blockEnd()`
  Returns the exclusive end of the current skip block (the actual block boundary from the skipper), regardless of match state.
  `long`
  `cost()`
  Returns the estimated cost of this `DocIdSetIterator`.
  `int`
  `docIDRunEnd()`
  Returns the end of the run of consecutive doc IDs that match this `DocIdSetIterator` and that contains the current `DocIdSetIterator.docID()`, that is: one plus the last doc ID of the run.
  `SkipBlockRangeIterator.Match`
  `getMatch()`
  Returns the match state of the current positioned block
  `void`
  `intoBitSet(int upTo, FixedBitSet bitSet, int offset)`
  Load doc IDs into a `FixedBitSet`.
  `int`
  `nextDoc()`
  Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  ### Methods inherited from class org.apache.lucene.search.AbstractDocIdSetIterator

  `docID`

  ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

  `all, empty, range, slowAdvance`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### SkipBlockRangeIterator

    public SkipBlockRangeIterator(DocValuesSkipper skipper, long minValue, long maxValue)
    Creates a new SkipBlockRangeIterator
    Parameters:
      `skipper` - the DocValuesSkipper to use to check block bounds
      `minValue` - only return documents that lie within a block with a maximum value greater than this
      `maxValue` - only return documents that lie within a block with a minimum value less than this

- ## Method Details

  - ### nextDoc

    public int nextDoc() throws IOException
    Description copied from class: `DocIdSetIterator`
    Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
    NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    Specified by:
      `nextDoc` in class `DocIdSetIterator`
    Throws:
      `IOException`

  - ### advance

    public int advance(int target) throws IOException
    Description copied from class: `DocIdSetIterator`
    Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

    The behavior of this method is undefined when called with `target ≤ current` , or after the iterator has exhausted. Both cases may result in unpredicted behavior.

    When `target > current` it behaves as if written:

         int advance(int target) {
           int doc;
           while ((doc = nextDoc()) < target) {
           }
           return doc;
         }

    Some implementations are considerably more efficient than that.

    NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

    Specified by:
      `advance` in class `DocIdSetIterator`
    Throws:
      `IOException`

  - ### getMatch

    public SkipBlockRangeIterator.Match getMatch()
    Returns the match state of the current positioned block

    Should only be called when the iterator is positioned

  - ### cost

    public long cost()
    Description copied from class: `DocIdSetIterator`
    Returns the estimated cost of this `DocIdSetIterator`.

    This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

    Specified by:
      `cost` in class `DocIdSetIterator`

  - ### blockEnd

    public int blockEnd()
    Returns the exclusive end of the current skip block (the actual block boundary from the skipper), regardless of match state. `docIDRunEnd()` returns the same boundary for MAYBE and YES_IF_PRESENT blocks, but may extend beyond it for YES blocks.

  - ### docIDRunEnd

    public int docIDRunEnd() throws IOException
    Description copied from class: `DocIdSetIterator`
    Returns the end of the run of consecutive doc IDs that match this `DocIdSetIterator` and that contains the current `DocIdSetIterator.docID()`, that is: one plus the last doc ID of the run.
    1. The returned doc is greater than `DocIdSetIterator.docID()`.
    2. All docs in range `[docID(), docIDRunEnd())` match this iterator.
    3. The current position of this iterator is not affected by calling `DocIdSetIterator.docIDRunEnd()`.

    Note: It is illegal to call this method when the iterator is exhausted or not positioned.

    The default implementation assumes runs of a single doc ID and returns `DocIdSetIterator.docID()`) + 1.

    Overrides:
      `docIDRunEnd` in class `DocIdSetIterator`
    Throws:
      `IOException`

  - ### intoBitSet

    public void intoBitSet(int upTo, FixedBitSet bitSet, int offset) throws IOException
    Description copied from class: `DocIdSetIterator`
    Load doc IDs into a `FixedBitSet`. This should behave exactly as if implemented as below, which is the default implementation:

         for (int doc = docID(); doc < upTo; doc = nextDoc()) {
           bitSet.set(doc - offset);
         }

    Note: `offset` must be less than or equal to the `current doc ID`. Behaviour is undefined if this iterator is unpositioned.

    Note: It is important not to clear bits from `bitSet` that may be already set.

    Note: `offset` may be negative.

    Overrides:
      `intoBitSet` in class `DocIdSetIterator`
    Throws:
      `IOException`